Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.pattern
Class NameTest

    java.lang.Object
      net.sf.saxon.pattern.NodeTest
          net.sf.saxon.pattern.NameTest

All Implemented Interfaces:
  Serializable, QNameTest, ItemType

    public class NameTest

extends NodeTest
implements QNameTest

NodeTest is an interface that enables a test of whether a node has a particular name and type. A NameTest matches the node kind and the namespace URI and the local name.

Author:
  Michael H. Kay
See Also:
  Serialized Form

Constructor Summary
`NameTest(int nodeKind, int nameCode, NamePool namePool)` Create a NameTest to match nodes by their nameCode allocated from the NamePool
`NameTest(int nodeKind, NodeName name, NamePool pool)` Create a NameTest to match nodes by name
`NameTest(int nodeKind, String uri, String localName, NamePool namePool)` Create a NameTest to match nodes by name
`NameTest(NodeInfo node)` Create a NameTest for nodes of the same type and name as a given node

Method Summary
`boolean` | `equals(Object other)` Determines whether two NameTests are equal
`double` | `getDefaultPriority()` Determine the default priority of this node test when used on its own as a Pattern
`int` | `getFingerprint()` Get the fingerprint required
`NamePool` | `getNamePool()` Get the NamePool associated with this NameTest
`int` | `getNodeKindMask()` Get a mask indicating which kinds of nodes this NodeTest can match.
`int` | `getPrimitiveType()` Determine the types of nodes to which this pattern applies.
`IntSet` | `getRequiredNodeNames()` Get the set of node names allowed by this NodeTest.
`ItemType` | `getSuperType(TypeHierarchy th)` Get the type from which this item type is derived by restriction.
`int` | `hashCode()` Returns a hash code value for the object.
`boolean` | `matches(int nodeKind, NodeName name, int annotation)` Test whether this node test is satisfied by a given node.
`boolean` | `matches(NodeInfo node)` Test whether this node test is satisfied by a given node.
`boolean` | `matches(StructuredQName qname)` Test whether the NameTest matches a given QName
`boolean` | `matches(TinyTree tree, int nodeNr)` Test whether this node test is satisfied by a given node on a TinyTree.
`String` | `toString()`
`String` | `toString(NamePool pool)` Display the type descriptor for diagnostics

Methods inherited from class net.sf.saxon.pattern.NodeTest
`getAtomizedItemType, getContentType, getPrimitiveItemType, isAtomicType, isAtomizable, isNillable, isPlainType, matches, matchesItem, visitNamedSchemaComponents`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### NameTest

    public NameTest(int nodeKind,
                    String uri,
                    String localName,
                    NamePool namePool)

  Create a NameTest to match nodes by name

  Parameters:
    `nodeKind` - the kind of node, for example `Type.ELEMENT`
    `uri` - the namespace URI of the required nodes. Supply "" to match nodes that are in no namespace
    `localName` - the local name of the required nodes. Supply "" to match unnamed nodes
    `namePool` - the namePool holding the name codes
  Since:
    9.0

### NameTest

    public NameTest(int nodeKind,
                    int nameCode,
                    NamePool namePool)

  Create a NameTest to match nodes by their nameCode allocated from the NamePool

  Parameters:
    `nodeKind` - the kind of node, for example `Type.ELEMENT`
    `nameCode` - the nameCode representing the name of the node
    `namePool` - the namePool holding the name codes
  Since:
    8.4

### NameTest

    public NameTest(int nodeKind,
                    NodeName name,
                    NamePool pool)

  Create a NameTest to match nodes by name

  Parameters:
    `nodeKind` - the kind of node, for example `Type.ELEMENT`
    `name` - the name of the nodes that this NameTest will match
    `pool` - the namePool holding the name codes
  Since:
    9.4

### NameTest

    public NameTest(NodeInfo node)

  Create a NameTest for nodes of the same type and name as a given node

  Parameters:
    `node` - the node whose node kind and node name will form the basis of the NameTest

Method Detail

### getNamePool

    public NamePool getNamePool()

  Get the NamePool associated with this NameTest

  Returns:
    the NamePool

### matches

    public boolean matches(int nodeKind,
                           NodeName name,
                           int annotation)

  Test whether this node test is satisfied by a given node. This method is only fully supported for a subset of NodeTests, because it doesn't provide all the information needed to evaluate all node tests. In particular (a) it can't be used to evaluate a node test of the form element(N,T) or schema-element(E) where it is necessary to know whether the node is nilled, and (b) it can't be used to evaluate a node test of the form document-node(element(X)). This in practice means that it is used (a) to evaluate the simple node tests found in the XPath 1.0 subset used in XML Schema, and (b) to evaluate node tests where the node kind is known to be an attribute.

  Specified by:
    `matches` in class `NodeTest`
  Parameters:
    `nodeKind` - The kind of node to be matched
    `name` - identifies the expanded name of the node to be matched. The value should be null for a node with no name.
    `annotation` - The actual content type of the node

### matches

    public boolean matches(TinyTree tree,
                           int nodeNr)

  Test whether this node test is satisfied by a given node on a TinyTree. The node must be a document, element, text, comment, or processing instruction node. This method is provided so that when navigating a TinyTree a node can be rejected without actually instantiating a NodeInfo object.

  Overrides:
    `matches` in class `NodeTest`
  Parameters:
    `tree` - the TinyTree containing the node
    `nodeNr` - the number of the node within the TinyTree
  Returns:
    true if the node matches the NodeTest, otherwise false

### matches

    public boolean matches(NodeInfo node)

  Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.

  Overrides:
    `matches` in class `NodeTest`
  Parameters:
    `node` - the node to be matched

### matches

    public boolean matches(StructuredQName qname)

  Test whether the NameTest matches a given QName

  Specified by:
    `matches` in interface `QNameTest`
  Parameters:
    `qname` - the QName to be matched
  Returns:
    true if the name matches

### getDefaultPriority

    public final double getDefaultPriority()

  Determine the default priority of this node test when used on its own as a Pattern

  Specified by:
    `getDefaultPriority` in interface `ItemType`
  Returns:
    the default priority

### getFingerprint

    public int getFingerprint()

  Get the fingerprint required

  Overrides:
    `getFingerprint` in class `NodeTest`

### getPrimitiveType

    public int getPrimitiveType()

  Determine the types of nodes to which this pattern applies. Used for optimisation. For patterns that match nodes of several types, return Type.NODE

  Specified by:
    `getPrimitiveType` in interface `ItemType`
  Overrides:
    `getPrimitiveType` in class `NodeTest`
  Returns:
    the type of node matched by this pattern. e.g. Type.ELEMENT or Type.TEXT

### getSuperType

    public ItemType getSuperType(TypeHierarchy th)

  Get the type from which this item type is derived by restriction. This is the supertype in the XPath type heirarchy, as distinct from the Schema base type: this means that the supertype of xs:boolean is xs:anyAtomicType, whose supertype is item() (rather than xs:anySimpleType).

  In fact the concept of "supertype" is not really well-defined, because the types form a lattice rather than a hierarchy. The only real requirement on this function is that it returns a type that strictly subsumes this type, ideally as narrowly as possible.

  Specified by:
    `getSuperType` in interface `ItemType`
  Overrides:
    `getSuperType` in class `NodeTest`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    the supertype, or null if this type is item()

### getNodeKindMask

    public int getNodeKindMask()

  Get a mask indicating which kinds of nodes this NodeTest can match. This is a combination of bits: 1<
  Overrides:
    `getNodeKindMask` in class `NodeTest`
  Returns:
    a combination of bits: 1<

  ### getRequiredNodeNames

      public IntSet getRequiredNodeNames()

    Get the set of node names allowed by this NodeTest. This is returned as a set of Integer fingerprints. A null value indicates that all names are permitted (i.e. that there are no constraints on the node name. The default implementation returns null.

    Overrides:
      `getRequiredNodeNames` in class `NodeTest`
    Returns:
      the set of integer fingerprints of the node names that this node test can match.

  ### toString

      public String toString()

    Overrides:
      `toString` in class `Object`

  ### toString

      public String toString(NamePool pool)

    Description copied from class: `NodeTest`
    Display the type descriptor for diagnostics

    Specified by:
      `toString` in interface `ItemType`
    Overrides:
      `toString` in class `NodeTest`
    Parameters:
      `pool` - the name pool
    Returns:
      a string representation of the type, in notation resembling but not necessarily identical to XPath syntax

  ### hashCode

      public int hashCode()

    Returns a hash code value for the object.

    Overrides:
      `hashCode` in class `Object`

  ### equals

      public boolean equals(Object other)

    Determines whether two NameTests are equal

    Overrides:
      `equals` in class `Object`

  Overview | Package | Class | Tree | Deprecated | Index | Help
  PREV CLASS NEXT CLASS | FRAMES NO FRAMES
  SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

  Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.